// Persistence of Vision Ray Tracer Scene Description File
// File: .inc
// Vers: 0.5
// Desc: Sea Topic
// Date: Aug 31, 2000
// Auth: Jim Charter

#version unofficial MegaPov 0.5;     
 


#declare feather_prism_1a = 
prism{
	cubic_spline
	0,
	2.000000,
	13,
	<0.162747,0.002034>,
	<0.307185,0.000000>,
	<0.569614,0.002034>,
	<0.779150,0.006103>,
	<1.017168,0.022378>,
	<0.897142,0.095614>,
	<0.626575,0.128163>,
	<0.345837,0.103751>,
	<0.162747,0.063064>,
	<0.020343,0.022378>,
	<0.162747,0.002034>,
	<0.307185,0.000000>,
	<0.569614,0.002034>
	scale <1,1,.8>
}
#declare feather_prism_1b = 
prism{
	cubic_spline
	0,
	2.000000,
	13,
	<0.051850,0.028518>,
	<0.181476,0.002593>,
	<0.466654,0.002593>,
	<0.777756,0.028518>,
	<1.011083,0.054443>,
	<0.933307,0.132219>,
	<0.751831,0.184069>,
	<0.440728,0.184069>,
	<0.181476,0.132219>,
	<0.025925,0.054443>,
	<0.051850,0.028518>,
	<0.181476,0.002593>,
	<0.466654,0.002593>
	scale <1,1,.8>
}
#declare feather_prism_2 = 
prism{
	cubic_spline
	0,
	2.000000,
	13,
	<0.210526,0.028947>,
	<0.500000,0.002632>,
	<0.789474,0.002632>,
	<0.973684,0.028947>,
	<1.026316,0.081579>,
	<0.973684,0.134211>,
	<0.789474,0.160526>,
	<0.500000,0.160526>,
	<0.210526,0.134211>,
	<0.026316,0.081579>,
	<0.210526,0.028947>,
	<0.500000,0.002632>,
	<0.789474,0.002632>
	scale <1,1,.8>
}
#declare primary_feather_left_1 =
sphere { < 0, -1, 0 > 1 
            scale < 4, 1, 1 >  
            texture { t_primary_feather }
            interior_texture { t_wing_ventral }
            clipped_by  {  object { feather_prism_1a translate y*-1 }  }            
} 
#declare primary_feather_left_2 = 
mesh {
    triangle { < 0, 0, 0 >, <  .8, -.001, -.025 >, <   1,     0,     0 > uv_vectors < 0, 0 >, <  .8,-.025 >, <   1,     0 >}
    triangle { < 0, 0, 0 >, <   1,     0,     0 >, <  .9, -.001,  .075 > uv_vectors < 0, 0 >, <   1,    0 >, <  .9,  .075 >}
    triangle { < 0, 0, 0 >, <  .9, -.001,  .075 >, <  .6, -.001,  .100 > uv_vectors < 0, 0 >, <  .9, .075 >, <  .6,  .100 >}
    uv_mapping
    texture { t_primary_feather }
    interior_texture { t_wing_ventral }    
}

#declare primary_covert_left_1 =
sphere { < 0, -1, 0 > 1 
            scale < 4, 1, 1 >  
            texture { t_primary_covert }
            interior_texture { t_wing_ventral }
            clipped_by  {  object { feather_prism_1b translate y*-1 }  }            
}
#declare primary_covert_left_2 =
mesh {
    triangle { < 0, 0, 0 >, <  .6, -.001, -.025 >, <  .8,     0,     0 > uv_vectors < 0, 0 >, <  .6, -.025 >, <   1,     0 >}
    triangle { < 0, 0, 0 >, <  .8,     0,     0 >, <  .7, -.001,  .095 > uv_vectors < 0, 0 >, <  .8,     0 >, <  .9,  .095 >}
    triangle { < 0, 0, 0 >, <  .7, -.001,  .095 >, <  .4, -.001,  .120 > uv_vectors < 0, 0 >, <  .7,  .095 >, <  .6,  .120 >}
    uv_mapping
    texture { t_primary_covert }           
    interior_texture { t_wing_ventral }    
} 

#declare secondary_feather_left_1 =
sphere { < 0, -1, 0 > 1 
            scale < 4, 1, 1 >  
            texture { t_secondary_feather }
            interior_texture { t_wing_ventral }
            clipped_by  {  object { feather_prism_2 translate y*-1 }  }            
}
#declare secondary_feather_left_2 = 
mesh {
    triangle { < 0, 0, 0 >, <  .8, -.001, -.085 >, <  .9,     0,     0 > uv_vectors < 0, 0 >, <   .8, -.085 >, <   .9,     0 >}
    triangle { < 0, 0, 0 >, <  .9,     0,     0 >, <  .85, -.001,  .1  > uv_vectors < 0, 0 >, <   .9,     0 >, <  .85,  .1 >}
    triangle { < 0, 0, 0 >, <  .85, -.001,   .1 >, <  .4, -.001,  .110 > uv_vectors < 0, 0 >, <  .85,  .075 >, <  .4,  .110 >}
    uv_mapping
    texture { t_secondary_feather }
    interior_texture { t_wing_ventral }
}

#declare secondary_covert_left_1 =
sphere { < 0, -1, 0 > 1 
            scale < 4, 1, 1 >  
            texture { t_secondary_covert }
            interior_texture { t_wing_ventral }
            clipped_by  {  object { feather_prism_2 translate y*-1 }  }            
}
#declare secondary_covert_left_2 = 
mesh {
    triangle { < 0, 0, 0 >, <  .6, -.001, -.085 >, <  .7,     0,     0 >  uv_vectors  < 0, 0 >, <   .8, -.085 >, <   .9,     0 >}
    triangle { < 0, 0, 0 >, <  .7,     0,     0 >, <  .6, -.001,  .09  > uv_vectors < 0, 0 >, <     .9,     0 >, <  .85,  .1 >}
    triangle { < 0, 0, 0 >, <  .6, -.001,   .09 >, <  .3, -.001,  .100 > uv_vectors < 0, 0 >, <     .85,  .075 >, <   .4,  .110 >}
    uv_mapping
    texture { t_secondary_covert }         
    interior_texture { t_wing_ventral }    
}  